## libsdl3-mixer 3.1~git20251026~86c6b09+ds

=== test/CMakeLists.txt ===
# CMake script for building SDL_mixer tests

set(CMAKE_POSITION_INDEPENDENT_CODE OFF)

set(RESOURCE_FILES
)

function(add_sdl_mixer_test_executable TARGET)
    add_executable(${TARGET} ${ARGN})
    if("c_std_99" IN_LIST CMAKE_C_COMPILE_FEATURES)
      target_compile_features(${TARGET} PRIVATE c_std_99)
    endif()
    target_compile_definitions(${TARGET}
        PRIVATE
            $<TARGET_PROPERTY:${sdl3_mixer_target_name},COMPILE_DEFINITIONS>
    )
    sdl_add_warning_options(${TARGET} WARNING_AS_ERROR ${SDLMIXER_WERROR})
    target_link_libraries(${TARGET} PRIVATE SDL3_mixer::SDL3_mixer SDL3::SDL3)

    if(SDLMIXER_TESTS_INSTALL)
        install(
            TARGETS ${TARGET}
            DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/installed-tests/${PROJECT_NAME}"
        )
        if(MSVC)
            SDL_install_pdb("${TARGET}" "${CMAKE_INSTALL_LIBEXECDIR}/installed-tests/${PROJECT_NAME}")
        endif()
    endif()
endfunction()

add_sdl_mixer_test_executable(testaudiodecoder testaudiodecoder.c)
add_sdl_mixer_test_executable(testmixer testmixer.c)
add_sdl_mixer_test_executable(testspacialization testspatialization.c)

if(SDLMIXER_TESTS_INSTALL)
    install(
        FILES ${RESOURCE_FILES}
        DESTINATION "${CMAKE_INSTALL_LIBEXECDIR}/installed-tests/${PROJECT_NAME}"
    )
endif()

=== cmake/test/CMakeLists.txt ===
# This cmake build script is meant for verifying the various CMake configuration script.

cmake_minimum_required(VERSION 3.12...3.28)
project(sdl_test LANGUAGES C)

cmake_policy(SET CMP0074 NEW)

# Override CMAKE_FIND_ROOT_PATH_MODE to allow search for SDL3_mixer outside of sysroot
set(CMAKE_FIND_ROOT_PATH_MODE_PACKAGE NEVER)

include(FeatureSummary)

option(TEST_SHARED "Test linking to shared SDL3_mixer library" ON)
add_feature_info("TEST_SHARED" TEST_SHARED "Test linking with shared library")

option(TEST_STATIC "Test linking to static SDL3_mixer libary" ON)
add_feature_info("TEST_STATIC" TEST_STATIC "Test linking with static library")

if(ANDROID)
    macro(add_executable NAME)
        set(args ${ARGN})
        list(REMOVE_ITEM args WIN32)
        add_library(${NAME} SHARED ${args})
        unset(args)
    endmacro()
endif()

if(TEST_SHARED)
    find_package(SDL3 REQUIRED CONFIG COMPONENTS SDL3)
    find_package(SDL3_mixer REQUIRED CONFIG)
    add_executable(main_shared main.c)
    target_link_libraries(main_shared PRIVATE SDL3_mixer::SDL3_mixer-shared SDL3::SDL3)
endif()

if(TEST_STATIC)
    find_package(SDL3 REQUIRED CONFIG COMPONENTS SDL3)
    # some static vendored libraries use c++ (enable CXX after `find_package` might show a warning)
    enable_language(CXX)
    find_package(SDL3_mixer REQUIRED CONFIG)
    add_executable(main_static main.c)
    target_link_libraries(main_static PRIVATE SDL3_mixer::SDL3_mixer-static SDL3::SDL3)
endif()

feature_summary(WHAT ALL)

=== debian/changelog ===
libsdl3-mixer (3.1~git20251026~86c6b09+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * Build-depend on flac and libflac++-dev, for working find_package(FLAC).
    Workaround for: #1119138
  * d/source/lintian-overrides: Update

 -- Simon McVittie <smcv@debian.org>  Mon, 27 Oct 2025 15:16:50 +0000

=== debian/control ===
Source: libsdl3-mixer
Section: libs
Priority: optional
Maintainer: Debian SDL packages maintainers <pkg-sdl-maintainers@lists.alioth.debian.org>
Uploaders: Manuel A. Fernandez Montecelo <mafm@debian.org>, Simon McVittie <smcv@debian.org>
Standards-Version: 4.7.2
Rules-Requires-Root: no
Build-Depends: cmake,
               debhelper-compat (= 13),
               flac,
               libflac-dev,
               libflac++-dev,
               libmpg123-dev,
               libogg-dev,
               libopusfile-dev,
               libsdl3-dev (>= 3.3~),
               libvorbis-dev,
               pkgconf
Homepage: https://github.com/libsdl-org/SDL_mixer
Vcs-Browser: https://salsa.debian.org/sdl-team/libsdl3-mixer
Vcs-Git: https://salsa.debian.org/sdl-team/libsdl3-mixer.git


Package: libsdl3-mixer0
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends},
         ${misc:Depends}
Description: Mixer library for Simple DirectMedia Layer 3, libraries
 SDL_mixer is a sample multi-channel audio mixer library.  It supports any
 number of simultaneously playing channels of 16 bit stereo audio, plus a single
 channel of music, in various formats including FLAC, Ogg Vorbis, Opus, MP3 and
 WAV.
 .
 This library does not yet have a stable ABI. Other packages in Debian
 should not depend on it until its first upstream stable release (3.2.0).
 .
 This package contains the shared library.

Package: libsdl3-mixer-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         libflac-dev,
         libmpg123-dev,
         libogg-dev,
         libopusfile-dev,
         libsdl3-dev (>= 3.3~),
         libsdl3-mixer0 (= ${binary:Version}),
         libvorbis-dev,
Description: Mixer library for Simple DirectMedia Layer 3, development files
 SDL_mixer is a sample multi-channel audio mixer library.  It supports any
 number of simultaneously playing channels of 16 bit stereo audio, plus a single
 channel of music, in various formats including FLAC, Ogg Vorbis, Opus, MP3 and
 WAV.
 .
 This library does not yet have a stable ABI. Other packages in Debian
 should not depend on it until its first upstream stable release (3.2.0).
 .
 This package contains the development files.

Package: libsdl3-mixer-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Build-Profiles: <!nodoc>
Depends:
 ${misc:Depends},
Description: Mixer library for Simple DirectMedia Layer 3 - documentation
 SDL_mixer is a sample multi-channel audio mixer library.  It supports any
 number of simultaneously playing channels of 16 bit stereo audio, plus a single
 channel of music, in various formats including FLAC, Ogg Vorbis, Opus, MP3 and
 WAV.
 .
 This library does not yet have a stable ABI. Other packages in Debian
 should not depend on it until its first upstream stable release (3.2.0).
 .
 This package contains the reference manual and examples.

Package: libsdl3-mixer-tests
Build-Profiles: <!noinsttest>
Architecture: any
Section: misc
Depends: ${misc:Depends},
         ${shlibs:Depends},
         libsdl3-mixer0 (= ${binary:Version}),
Description: Mixer library for Simple DirectMedia Layer 3 - tests
 SDL_mixer is a sample multi-channel audio mixer library.  It supports any
 number of simultaneously playing channels of 16 bit stereo audio, plus a single
 channel of music, in various formats including FLAC, Ogg Vorbis, Opus, MP3 and
 WAV.
 .
 This package contains manual tests. Automated tests will be added to this
 package if they become available upstream.

## libsdl3-mixer 3.1~git20251030~8c516fc+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16...4.0)

if(NOT DEFINED CMAKE_BUILD_TYPE)
  set(cmake_build_type_undefined 1)
endif()

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_LIST_DIR}/cmake")

# See docs/release_checklist.md
set(MAJOR_VERSION 3)
set(MINOR_VERSION 1)
set(MICRO_VERSION 0)
set(SDL_REQUIRED_VERSION 3.3.0)

project(SDL3_mixer
    LANGUAGES C
    VERSION "${MAJOR_VERSION}.${MINOR_VERSION}.${MICRO_VERSION}"
)

include("${SDL3_mixer_SOURCE_DIR}/cmake/GetGitRevisionDescription.cmake")
include("${SDL3_mixer_SOURCE_DIR}/cmake/PrivateSdlFunctions.cmake")
include("${SDL3_mixer_SOURCE_DIR}/cmake/sdlcpu.cmake")
include("${SDL3_mixer_SOURCE_DIR}/cmake/sdlmanpages.cmake")
include("${SDL3_mixer_SOURCE_DIR}/cmake/sdlplatform.cmake")
sdl_calculate_derived_version_variables(${MAJOR_VERSION} ${MINOR_VERSION} ${MICRO_VERSION})

message(STATUS "Configuring ${PROJECT_NAME} ${PROJECT_VERSION}")

if(CMAKE_SOURCE_DIR STREQUAL PROJECT_SOURCE_DIR)
    set(SDLMIXER_ROOTPROJECT ON)
else()
    set(SDLMIXER_ROOTPROJECT OFF)
endif()

# By default, configure in RelWithDebInfo configuration
if(SDLMIXER_ROOTPROJECT)
  get_property(is_multi_config GLOBAL PROPERTY GENERATOR_IS_MULTI_CONFIG)
  if(is_multi_config)
    # The first item in CMAKE_CONFIGURATION_TYPES is the default configuration
    if(DEFINED CMAKE_CONFIGURATION_TYPES AND "RelWithDebInfo" IN_LIST CMAKE_CONFIGURATION_TYPES)
      list(REMOVE_ITEM CMAKE_CONFIGURATION_TYPES "RelWithDebInfo")
      list(INSERT CMAKE_CONFIGURATION_TYPES 0 "RelWithDebInfo")
      set(CMAKE_CONFIGURATION_TYPES "${CMAKE_CONFIGURATION_TYPES}" CACHE STRING "CMake configuration types" FORCE)
    endif()
  else()
    if(cmake_build_type_undefined)
      set(CMAKE_BUILD_TYPE "RelWithDebInfo" CACHE STRING "CMake build type" FORCE)
    endif()
  endif()
endif()

# option() honors normal variables.
cmake_policy(SET CMP0077 NEW)
set(CMAKE_POLICY_DEFAULT_CMP0077 NEW)

if(POLICY CMP0112)
    # Target file component generator expressions do not add target dependencies.
    cmake_policy(SET CMP0112 NEW)
endif()

if(POLICY CMP0099)
    # Make `INTERFACE_LINK_DIRECTORIES` a transitive usage requirement.
    # This is needed for static dependencies which have transitive dependencies
    # outside of compiler default search paths.
    cmake_policy(SET CMP0099 NEW)
endif()

# Assume MSVC projects don't have a package manager and need vendored dependencies (by default).
# Most other platforms have some kind of package manager.
# FIXME: consider a package manager such as conan/vcpkg instead of vendoring
if(ANDROID OR MSVC)
    set(vendored_default ON)
else()
    set(vendored_default OFF)
endif()

set(sdl3mixer_install_enableable ON)
if((TARGET SDL3-shared OR TARGET SDL3-static) AND SDL_DISABLE_INSTALL)
    # Cannot install SDL3_mixer when SDL3 is built in same built, and is not installed.
    set(sdl3mixer_install_enableable OFF)
endif()

if(NOT DEFINED CMAKE_FIND_PACKAGE_PREFER_CONFIG)
    set(CMAKE_FIND_PACKAGE_PREFER_CONFIG ON)
endif()

include(CheckIncludeFile)
include(CheckSymbolExists)
include(CMakeDependentOption)
include(CMakePackageConfigHelpers)
include(GNUInstallDirs)
include(PkgConfigHelper)

set(PLATFORM_SUPPORTS_SHARED ON)
if(EMSCRIPTEN OR VITA OR PSP OR PS2 OR N3DS OR RISCOS)
  set(PLATFORM_SUPPORTS_SHARED OFF)
endif()

option(CMAKE_POSITION_INDEPENDENT_CODE "Build static libraries with -fPIC" ${PLATFORM_SUPPORTS_SHARED})
cmake_dependent_option(BUILD_SHARED_LIBS "Build the library as a shared library" ON PLATFORM_SUPPORTS_SHARED OFF)

cmake_dependent_option(SDLMIXER_INSTALL "Enable SDL3mixer install target" ${SDLMIXER_ROOTPROJECT} "${sdl3mixer_install_enableable}" OFF)
cmake_dependent_option(SDLMIXER_INSTALL_CPACK "Create binary SDL3_mixer archive using CPack" ${SDLMIXER_ROOTPROJECT} "SDLMIXER_INSTALL" OFF)
cmake_dependent_option(SDLMIXER_INSTALL_MAN "Install man pages for SDL3_mixer" OFF "SDLMIXER_INSTALL" OFF)
cmake_dependent_option(SDLMIXER_DEPS_SHARED "Load dependencies dynamically" ON PLATFORM_SUPPORTS_SHARED OFF)
cmake_dependent_option(SDLMIXER_RELOCATABLE "Create relocatable SDL_mixer package" "${MSVC}" SDLMIXER_INSTALL OFF)
option(SDLMIXER_VENDORED "Use vendored third-party libraries" ${vendored_default})
option(SDLMIXER_WERROR "Treat warnings as errors" OFF)

option(SDLMIXER_STRICT "Fail when a dependency could not be found" OFF)
set(required "")
set(fatal_error "STATUS")
if(SDLMIXER_STRICT)
  set(required "REQUIRED")
  set(fatal_error "FATAL_ERROR")
endif()

option(SDLMIXER_TESTS "Build unit tests?" OFF)
option(SDLMIXER_TESTS_INSTALL "Install unit tests?" OFF)

# These are implemented in SDL_mixer itself, not using a third-party library.
option(SDLMIXER_AIFF "Enable AIFF audio" ON)
option(SDLMIXER_WAVE "Enable WAVE audio" ON)
option(SDLMIXER_VOC "Enable VOC audio" ON)
option(SDLMIXER_AU "Enable AU audio" ON)

# Decoders that use third-party dependencies, even if they are compiled in, vendored, etc.
option(SDLMIXER_FLAC_LIBFLAC "Enable FLAC audio using libFLAC" ON)
cmake_dependent_option(SDLMIXER_FLAC_LIBFLAC_SHARED "Dynamically load LIBFLAC" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_FLAC_LIBFLAC OFF)

option(SDLMIXER_FLAC_DRFLAC "Enable FLAC audio using drflac" ON)

option(SDLMIXER_GME "Support loading GME audio via game-music-emu" ON)
option(SDLMIXER_GME_SHARED "Dynamically load libgme" "${SDLMIXER_DEPS_SHARED}")

option(SDLMIXER_MOD_XMP "Support loading MOD audio via libxmp" ON)
cmake_dependent_option(SDLMIXER_MOD_XMP_LITE "Use libxmp-lite instead of libxmp" OFF "SDLMIXER_MOD_XMP;NOT SDLMIXER_VENDORED" OFF)
cmake_dependent_option(SDLMIXER_MOD_XMP_SHARED "Dynamically load libxmp(-lite)" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MOD_XMP OFF)

option(SDLMIXER_MP3_DRMP3 "Support loading MP3 audio via dr_mp3" ON)
option(SDLMIXER_MP3_MPG123 "Support loading MP3 audio via libmpg123" ON)
cmake_dependent_option(SDLMIXER_MP3_MPG123_SHARED "Dynamically load mpg123" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MP3_MPG123 OFF)

cmake_dependent_option(SDLMIXER_MIDI_FLUIDSYNTH "Support FluidSynth MIDI output" ON "NOT SDLMIXER_VENDORED" OFF)
cmake_dependent_option(SDLMIXER_MIDI_FLUIDSYNTH_SHARED "Dynamically load libfluidsynth" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MIDI_FLUIDSYNTH OFF)

option(SDLMIXER_MIDI_TIMIDITY "Support timidity MIDI output" ON)

option(SDLMIXER_OPUS "Enable Opus audio via libopus" ON)
cmake_dependent_option(SDLMIXER_OPUS_SHARED "Dynamically load libopus" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_OPUS OFF)

option(SDLMIXER_VORBIS_STB "Enable Ogg Vorbis audio via stb_vorbis" ON)
option(SDLMIXER_VORBIS_VORBISFILE "Enable Ogg Vorbis audio via libvorbisfile" ON)
option(SDLMIXER_VORBIS_TREMOR "Enable Ogg Vorbis audio via libvorbisidec ('tremor')" OFF)

if (SDLMIXER_VORBIS_VORBISFILE AND SDLMIXER_VORBIS_TREMOR)
    message(FATAL_ERROR "Both SDLMIXER_VORBIS_VORBISFILE and SDLMIXER_VORBIS_TREMOR are both enabled, but only one can be used")
endif()

cmake_dependent_option(SDLMIXER_VORBIS_VORBISFILE_SHARED "Dynamically load vorbisfile library" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_VORBIS_VORBISFILE OFF)
cmake_dependent_option(SDLMIXER_VORBIS_TREMOR_SHARED "Dynamically load vorbisidec ('tremor') library" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_VORBIS_TREMOR OFF)

option(SDLMIXER_WAVPACK "Enable WavPack audio" ON)
cmake_dependent_option(SDLMIXER_WAVPACK_DSD "Enable WavPack DSD audio support" OFF SDLMIXER_WAVPACK OFF)
cmake_dependent_option(SDLMIXER_WAVPACK_SHARED "Dynamically load WavPack library" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_WAVPACK OFF)

if(SDLMIXER_VORBIS_TREMOR OR SDLMIXER_VORBIS_VORBISFILE OR SDLMIXER_FLAC_LIBFLAC OR SDLMIXER_OPUS)
    set(SDLMIXER_OGG TRUE)
    set(SDLMIXER_OGG_install FALSE)
    if(SDLMIXER_VORBIS_VORBISFILE_SHARED OR SDLMIXER_FLAC_SHARED OR SDLMIXER_OPUS_SHARED)
        set(SDLMIXER_OGG_SHARED TRUE)
        set(SDLMIXER_OGG_install TRUE)
    else()
        set(SDLMIXER_OGG_SHARED FALSE)
        if(NOT SDLMIXER_BUILD_SHARED_LIBS)
            set(SDLMIXER_OGG_install TRUE)
        endif()
    endif()
else()
    set(SDLMIXER_OGG FALSE)
endif()

# Save BUILD_SHARED_LIBS variable
set(SDLMIXER_BUILD_SHARED_LIBS ${BUILD_SHARED_LIBS})

set(sdl_required_components Headers)

if(SDLMIXER_BUILD_SHARED_LIBS)
    set(sdl3_mixer_target_name SDL3_mixer-shared)
    set(sdl3_target_name SDL3::SDL3-shared)

    list(APPEND sdl_required_components SDL3-shared)
else()
    set(sdl3_mixer_target_name SDL3_mixer-static)
    set(sdl3_target_name SDL3::SDL3)
endif()

if(NOT TARGET SDL3::Headers OR NOT TARGET ${sdl3_target_name})
    find_package(SDL3 ${SDL_REQUIRED_VERSION} REQUIRED COMPONENTS ${sdl_required_components})
endif()

SDL_DetectTargetCPUArchitectures(SDL_CPU_NAMES)
SDL_DetectCMakePlatform()

set(BUILD_SHARED_LIBS ${SDLMIXER_BUILD_SHARED_LIBS})
add_library(${sdl3_mixer_target_name}
    src/SDL_mixer.c
    src/SDL_mixer_metadata_tags.c
    src/SDL_mixer_spatialization.c
    src/decoder_aiff.c
    src/decoder_au.c
    src/decoder_drflac.c
    src/decoder_drmp3.c
    src/decoder_flac.c
    src/decoder_fluidsynth.c
    src/decoder_gme.c
    src/decoder_mpg123.c
    src/decoder_opus.c
    src/decoder_raw.c
    src/decoder_sinewave.c
    src/decoder_stb_vorbis.c
    src/decoder_timidity.c
    src/decoder_voc.c
    src/decoder_vorbis.c
    src/decoder_wav.c
    src/decoder_wavpack.c
    src/decoder_xmp.c
)
add_library(SDL3_mixer::${sdl3_mixer_target_name} ALIAS ${sdl3_mixer_target_name})
if(NOT TARGET SDL3_mixer::SDL3_mixer)
    add_library(SDL3_mixer::SDL3_mixer ALIAS ${sdl3_mixer_target_name})
endif()
if("c_std_99" IN_LIST CMAKE_C_COMPILE_FEATURES)
    target_compile_features(${sdl3_mixer_target_name} PRIVATE c_std_99)
else()
    message(WARNING "target_compile_features does not know c_std_99 for C compiler")
endif()
target_include_directories(${sdl3_mixer_target_name}
    PUBLIC
        "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>"
        "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
    PRIVATE
        src
        src/codecs
)
target_compile_definitions(${sdl3_mixer_target_name} PRIVATE
    BUILD_SDL
    SDL_BUILD_MAJOR_VERSION=${MAJOR_VERSION}
    SDL_BUILD_MINOR_VERSION=${MINOR_VERSION}
    SDL_BUILD_MICRO_VERSION=${MICRO_VERSION}
)
# Make sure SDL3's include directory comes first
target_include_directories(${sdl3_mixer_target_name} PRIVATE $<TARGET_PROPERTY:SDL3::Headers,INTERFACE_INCLUDE_DIRECTORIES>)
target_link_libraries(${sdl3_mixer_target_name} PUBLIC SDL3::Headers)
if(SDLMIXER_BUILD_SHARED_LIBS)
    target_link_libraries(${sdl3_mixer_target_name} PRIVATE SDL3::SDL3-shared)
endif()
sdl_add_warning_options(${sdl3_mixer_target_name} WARNING_AS_ERROR ${SDLMIXER_WERROR})
if(WIN32 AND BUILD_SHARED_LIBS)
    target_sources(${sdl3_mixer_target_name} PRIVATE
        src/version.rc
    )
    if(MINGW)
        target_link_options(${sdl3_mixer_target_name} PRIVATE -static-libgcc)
    endif()
endif()
set_target_properties(${sdl3_mixer_target_name} PROPERTIES
    OUTPUT_NAME "SDL3_mixer"
    DEFINE_SYMBOL DLL_EXPORT
    EXPORT_NAME ${sdl3_mixer_target_name}
    C_VISIBILITY_PRESET "hidden"
)

sdl_target_link_option_version_file(${sdl3_mixer_target_name} "${CMAKE_CURRENT_SOURCE_DIR}/src/SDL_mixer.sym")

if(NOT ANDROID)
    set_target_properties(${sdl3_mixer_target_name} PROPERTIES
        SOVERSION "${SO_VERSION_MAJOR}"
        VERSION "${SO_VERSION}"
    )
    if(APPLE)
        cmake_minimum_required(VERSION 3.17...3.28)
        set_target_properties(${sdl3_mixer_target_name} PROPERTIES
            MACHO_COMPATIBILITY_VERSION "${DYLIB_COMPAT_VERSION}"
            MACHO_CURRENT_VERSION "${DYLIB_CURRENT_VERSION}"
        )
    endif()
endif()
if(SDLMIXER_BUILD_SHARED_LIBS)
    if(WIN32)
        set_target_properties(${sdl3_mixer_target_name} PROPERTIES
            PREFIX ""
            DLL_NAME_WITH_SOVERSION FALSE
        )
    endif()
else()
    if(MSVC)
        set_target_properties(${sdl3_mixer_target_name} PROPERTIES
            OUTPUT_NAME "SDL3_mixer-static"
        )
    endif()
endif()

=== build-scripts/pkg-support/mingw/Makefile ===
#
# Makefile for installing the mingw32 version of the SDL_mixer library

DESTDIR = /usr/local
ARCHITECTURES := i686-w64-mingw32 x86_64-w64-mingw32

default:
	@echo "Run \"make install-i686\" to install 32-bit"
	@echo "Run \"make install-x86_64\" to install 64-bit"
	@echo "Run \"make install-all\" to install both"
	@echo "Add DESTDIR=/custom/path to change the destination folder"

install:
	@if test -d $(ARCH) && test -d $(DESTDIR); then \
		(cd $(ARCH) && cp -rv bin include lib share $(DESTDIR)/); \
	else \
		echo "*** ERROR: $(ARCH) or $(DESTDIR) does not exist!"; \
		exit 1; \
	fi

install-i686:
	$(MAKE) install ARCH=i686-w64-mingw32

install-x86_64:
	$(MAKE) install ARCH=x86_64-w64-mingw32

install-all:
	@if test -d $(DESTDIR); then \
		mkdir -p $(DESTDIR)/cmake; \
		cp -rv cmake/* $(DESTDIR)/cmake; \
		for arch in $(ARCHITECTURES); do \
			$(MAKE) install ARCH=$$arch DESTDIR=$(DESTDIR)/$$arch; \
		done \
	else \
		echo "*** ERROR: $(DESTDIR) does not exist!"; \
		exit 1; \
	fi

.PHONY: default install install-i686 install-x86_64 install-all

=== debian/changelog ===
libsdl3-mixer (3.1~git20251030~8c516fc+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * Revert workaround for #1119138

 -- Simon McVittie <smcv@debian.org>  Fri, 31 Oct 2025 18:15:38 +0000

=== debian/control ===
--- 
+++ 
@@ -7,9 +7,7 @@
 Rules-Requires-Root: no
 Build-Depends: cmake,
                debhelper-compat (= 13),
-               flac,
                libflac-dev,
-               libflac++-dev,
                libmpg123-dev,
                libogg-dev,
                libopusfile-dev,

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS := hardening=+all

export DEB_CFLAGS_MAINT_APPEND  := -pipe -Wall

# TODO: We will need this if we re-enable MIDI playback:
# bug #715461, provide default soundfont paths
#export DEB_CPPFLAGS_MAINT_APPEND := -DMIX_INIT_SOUNDFONT_PATHS="\"/usr/share/sounds/sf3/default-GM.sf3\""

include /usr/share/dpkg/default.mk

built_binaries := $(shell dh_listpackages)

ifneq (,$(filter-out experimental UNRELEASED,$(DEB_DISTRIBUTION)))
$(error This version of SDL_mixer is not yet suitable for testing/unstable)
endif

confflags :=
confflags += -DSDLMIXER_DEPS_SHARED=OFF
confflags += -DSDLMIXER_STRICT=ON
confflags += -DSDLMIXER_VENDORED=OFF
confflags += -DSDLMIXER_WERROR=OFF

ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS))$(filter %-tests,$(built_binaries)),nocheck)
confflags += -DSDLMIXER_TESTS=ON
endif

ifneq ($(filter %-doc,$(built_binaries)),)
confflags += -DSDLMIXER_INSTALL_MAN=ON
endif

ifneq ($(filter %-tests,$(built_binaries)),)
confflags += -DSDLMIXER_SAMPLES=ON
confflags += -DSDLMIXER_SAMPLES_INSTALL=ON
confflags += -DSDLMIXER_TESTS_INSTALL=ON
endif

confflags += -DSDLMIXER_FLAC=ON
confflags += -DSDLMIXER_FLAC_LIBFLAC=ON
confflags += -DSDLMIXER_FLAC_DRFLAC=OFF

# gme has caused security issues in the past, so the conservative approach
# is to leave it switched off until someone needs it
confflags += -DSDLMIXER_GME=OFF

# Enabling a previously disabled format is more compatible than disabling a
# previously enabled format, so initially turn off MIDI for the SDL3 branch.
confflags += -DSDLMIXER_MIDI=OFF
# Historically we enabled both fluidsynth and timidity by default, but it's
# not clear that it was useful to do so.
confflags += -DSDLMIXER_MIDI_FLUIDSYNTH=OFF
confflags += -DSDLMIXER_MIDI_NATIVE=OFF
confflags += -DSDLMIXER_MIDI_TIMIDITY=OFF

# Enabling a previously disabled format is more compatible than disabling a
# previously enabled format, so initially turn off soundtracker playback
# for the SDL3 branch.
confflags += -DSDLMIXER_MOD=OFF
confflags += -DSDLMIXER_MOD_XMP=OFF
confflags += -DSDLMIXER_MOD_XMP_LITE=OFF

confflags += -DSDLMIXER_MP3=ON
confflags += -DSDLMIXER_MP3_DRMP3=OFF
confflags += -DSDLMIXER_MP3_MPG123=ON

confflags += -DSDLMIXER_OPUS=ON
confflags += -DSDLMIXER_SNDFILE=OFF
confflags += -DSDLMIXER_VORBIS=VORBISFILE
confflags += -DSDLMIXER_WAVE=ON

# Enabling a previously disabled format is more compatible than disabling a
# previously enabled format, so initially turn off wavpack for the SDL3
# branch.
confflags += -DSDLMIXER_WAVPACK=OFF

%:
	dh $@ --buildsystem=cmake

override_dh_auto_configure:
	echo "$(DEB_VERSION_UPSTREAM_REVISION)" > VERSION.txt
	dh_auto_configure -- $(confflags)

override_dh_compress:
	dh_compress -Xplaymus.c -Xplaywave.c

# debhelper >= 13.4 makes all of /usr/libexec executable, which is not
# quite right for installed-tests
override_dh_fixperms:
	dh_fixperms -Xusr/libexec/installed-tests
ifneq ($(filter %-tests,$(built_binaries)),)
	chmod --recursive --changes a+rX,u+w,og-w debian/*-tests/usr/libexec/installed-tests
endif

=== debian/tests/control ===
Tests: libsdl3-mixer-dev
Restrictions: allow-stderr, superficial
Depends:
 alsa-utils,
 build-essential,
 cmake,
 libsdl3-mixer-dev,
 ninja-build,
 pkgconf,
 xauth,
 xvfb,

=== debian/watch ===
Version: 5

Source: https://github.com/libsdl-org/SDL_mixer.git
Matching-Pattern: HEAD
Compression: xz
Dversion-Mangle: s/[+~](?:ds|dfsg)[0-9]*$//;s/\+(?:git)?[0-9]+(?:\+g[0-9a-f]*)?$//
Mode: git
Pgp-Mode: none
Git-Pretty: 3.1~git%cd~%h
Repack: yes
Repacksuffix: +ds

## libsdl3-mixer 3.1~git20251207~fb31486+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 set(MAJOR_VERSION 3)
 set(MINOR_VERSION 1)
 set(MICRO_VERSION 0)
-set(SDL_REQUIRED_VERSION 3.3.0)
+set(SDL_REQUIRED_VERSION 3.3.3)
 
 project(SDL3_mixer
     LANGUAGES C
@@ -279,11 +279,14 @@
         VERSION "${SO_VERSION}"
     )
     if(APPLE)
-        cmake_minimum_required(VERSION 3.17...3.28)
         set_target_properties(${sdl3_mixer_target_name} PROPERTIES
             MACHO_COMPATIBILITY_VERSION "${DYLIB_COMPAT_VERSION}"
             MACHO_CURRENT_VERSION "${DYLIB_CURRENT_VERSION}"
         )
+        set_property(TARGET ${sdl3_mixer_target_name} APPEND PROPERTY LINK_DEPENDS
+                "${PROJECT_SOURCE_DIR}/src/SDL_mixer.exports")
+        target_link_options(${sdl3_mixer_target_name} PRIVATE
+                "SHELL:-Wl,-exported_symbols_list,${PROJECT_SOURCE_DIR}/src/SDL_mixer.exports")
     endif()
 endif()
 if(SDLMIXER_BUILD_SHARED_LIBS)
@@ -292,12 +295,3 @@
             PREFIX ""
             DLL_NAME_WITH_SOVERSION FALSE
         )
-    endif()
-else()
-    if(MSVC)
-        set_target_properties(${sdl3_mixer_target_name} PROPERTIES
-            OUTPUT_NAME "SDL3_mixer-static"
-        )
-    endif()
-endif()
-

=== debian/changelog ===
libsdl3-mixer (3.1~git20251207~fb31486+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/control: Require current SDL preview release

 -- Simon McVittie <smcv@debian.org>  Mon, 08 Dec 2025 19:05:20 +0000

## libsdl3-mixer 3.1~git20251230~3a1965b+ds

=== debian/changelog ===
libsdl3-mixer (3.1~git20251230~3a1965b+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/libsdl3-mixer0.symbols: Update

 -- Simon McVittie <smcv@debian.org>  Wed, 31 Dec 2025 10:41:18 +0000

=== debian/control ===
--- 
+++ 
@@ -11,7 +11,7 @@
                libmpg123-dev,
                libogg-dev,
                libopusfile-dev,
-               libsdl3-dev (>= 3.3~),
+               libsdl3-dev (>= 3.3.3),
                libvorbis-dev,
                pkgconf
 Homepage: https://github.com/libsdl-org/SDL_mixer

## libsdl3-mixer 3.1~git20260101~3045b35+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 set(MAJOR_VERSION 3)
 set(MINOR_VERSION 1)
 set(MICRO_VERSION 0)
-set(SDL_REQUIRED_VERSION 3.3.3)
+set(SDL_REQUIRED_VERSION 3.4.0)
 
 project(SDL3_mixer
     LANGUAGES C

=== debian/changelog ===
libsdl3-mixer (3.1~git20260101~3045b35+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/copyright: Update
  * d/control: Require SDL 3.4.0 stable release
  * d/control: Standards-Version: 4.7.3 (no changes required)
  * d/control: Remove unnecessary Priority field
  * d/control: Remove unnecessary Rules-Requires-Root: no

 -- Simon McVittie <smcv@debian.org>  Fri, 02 Jan 2026 18:27:53 +0000

## libsdl3-mixer 3.1~git20260120~7b5b902+ds

=== debian/changelog ===
libsdl3-mixer (3.1~git20260120~7b5b902+ds-1) experimental; urgency=medium

  * New upstream snapshot
  * d/libsdl3-mixer0.symbols: Update

 -- Simon McVittie <smcv@debian.org>  Tue, 20 Jan 2026 18:19:34 +0000

## libsdl3-mixer 3.1.2+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,7 @@
 # See docs/release_checklist.md
 set(MAJOR_VERSION 3)
 set(MINOR_VERSION 1)
-set(MICRO_VERSION 0)
+set(MICRO_VERSION 2)
 set(SDL_REQUIRED_VERSION 3.4.0)
 
 project(SDL3_mixer
@@ -124,27 +124,35 @@
 option(SDLMIXER_VOC "Enable VOC audio" ON)
 option(SDLMIXER_AU "Enable AU audio" ON)
 
+option(SDLMIXER_FLAC "Enable FLAC audio" ON)
+
 # Decoders that use third-party dependencies, even if they are compiled in, vendored, etc.
-option(SDLMIXER_FLAC_LIBFLAC "Enable FLAC audio using libFLAC" ON)
+cmake_dependent_option(SDLMIXER_FLAC_LIBFLAC "Enable FLAC audio using libFLAC" ON SDLMIXER_FLAC OFF)
 cmake_dependent_option(SDLMIXER_FLAC_LIBFLAC_SHARED "Dynamically load LIBFLAC" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_FLAC_LIBFLAC OFF)
 
-option(SDLMIXER_FLAC_DRFLAC "Enable FLAC audio using drflac" ON)
+cmake_dependent_option(SDLMIXER_FLAC_DRFLAC "Enable FLAC audio using drflac" ON SDLMIXER_FLAC OFF)
 
 option(SDLMIXER_GME "Support loading GME audio via game-music-emu" ON)
 option(SDLMIXER_GME_SHARED "Dynamically load libgme" "${SDLMIXER_DEPS_SHARED}")
 
-option(SDLMIXER_MOD_XMP "Support loading MOD audio via libxmp" ON)
+option(SDLMIXER_MOD "Support MOD audio" ON)
+
+cmake_dependent_option(SDLMIXER_MOD_XMP "Support loading MOD audio via libxmp" ON SDLMIXER_MOD OFF)
 cmake_dependent_option(SDLMIXER_MOD_XMP_LITE "Use libxmp-lite instead of libxmp" OFF "SDLMIXER_MOD_XMP;NOT SDLMIXER_VENDORED" OFF)
 cmake_dependent_option(SDLMIXER_MOD_XMP_SHARED "Dynamically load libxmp(-lite)" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MOD_XMP OFF)
 
-option(SDLMIXER_MP3_DRMP3 "Support loading MP3 audio via dr_mp3" ON)
-option(SDLMIXER_MP3_MPG123 "Support loading MP3 audio via libmpg123" ON)
+option(SDLMIXER_MP3 "Enable MP3 audio" ON)
+
+cmake_dependent_option(SDLMIXER_MP3_DRMP3 "Support loading MP3 audio via dr_mp3" ON SDLMIXER_MP3 OFF)
+cmake_dependent_option(SDLMIXER_MP3_MPG123 "Support loading MP3 audio via libmpg123" ON SDLMIXER_MP3 OFF)
 cmake_dependent_option(SDLMIXER_MP3_MPG123_SHARED "Dynamically load mpg123" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MP3_MPG123 OFF)
 
-cmake_dependent_option(SDLMIXER_MIDI_FLUIDSYNTH "Support FluidSynth MIDI output" ON "NOT SDLMIXER_VENDORED" OFF)
+option(SDLMIXER_MIDI "Enable MIDI audio" ON)
+
+cmake_dependent_option(SDLMIXER_MIDI_FLUIDSYNTH "Support FluidSynth MIDI output" ON "SDLMIXER_MIDI;NOT SDLMIXER_VENDORED" OFF)
 cmake_dependent_option(SDLMIXER_MIDI_FLUIDSYNTH_SHARED "Dynamically load libfluidsynth" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_MIDI_FLUIDSYNTH OFF)
 
-option(SDLMIXER_MIDI_TIMIDITY "Support timidity MIDI output" ON)
+cmake_dependent_option(SDLMIXER_MIDI_TIMIDITY "Support timidity MIDI output" ON SDLMIXER_MIDI OFF)
 
 option(SDLMIXER_OPUS "Enable Opus audio via libopus" ON)
 cmake_dependent_option(SDLMIXER_OPUS_SHARED "Dynamically load libopus" "${SDLMIXER_DEPS_SHARED}" SDLMIXER_OPUS OFF)
@@ -198,6 +206,12 @@
 if(NOT TARGET SDL3::Headers OR NOT TARGET ${sdl3_target_name})
     find_package(SDL3 ${SDL_REQUIRED_VERSION} REQUIRED COMPONENTS ${sdl_required_components})
 endif()
+
+set(install_license_names)
+macro(register_license NAME FILE)
+    list(APPEND install_license_names ${NAME})
+    set(install_license_${NAME} "${FILE}")
+endmacro()
 
 SDL_DetectTargetCPUArchitectures(SDL_CPU_NAMES)
 SDL_DetectCMakePlatform()
@@ -281,17 +295,3 @@
     if(APPLE)
         set_target_properties(${sdl3_mixer_target_name} PROPERTIES
             MACHO_COMPATIBILITY_VERSION "${DYLIB_COMPAT_VERSION}"
-            MACHO_CURRENT_VERSION "${DYLIB_CURRENT_VERSION}"
-        )
-        set_property(TARGET ${sdl3_mixer_target_name} APPEND PROPERTY LINK_DEPENDS
-                "${PROJECT_SOURCE_DIR}/src/SDL_mixer.exports")
-        target_link_options(${sdl3_mixer_target_name} PRIVATE
-                "SHELL:-Wl,-exported_symbols_list,${PROJECT_SOURCE_DIR}/src/SDL_mixer.exports")
-    endif()
-endif()
-if(SDLMIXER_BUILD_SHARED_LIBS)
-    if(WIN32)
-        set_target_properties(${sdl3_mixer_target_name} PROPERTIES
-            PREFIX ""
-            DLL_NAME_WITH_SOVERSION FALSE
-        )

=== debian/changelog ===
libsdl3-mixer (3.1.2+ds-1) experimental; urgency=medium

  * New upstream preview release, in preparation for the first stable
    release 3.2.0
  * d/rules: Update build options
  * d/libsdl3-mixer-doc.examples: Install simple example from upstream
  * d/watch: Watch for preview releases
  * d/libsdl3-mixer0.symbols: Generate dependencies on the preview release.
    This lets us be sure that we've avoided incompatible ABIs that existed
    in experimental while the new API/ABI was under development.
  * Build and install the very simple example player, docs/hello.c.
    test/testmixer.c is now more complicated than a trivial audio player
    (it exercises delays and looping) but docs/hello.c has taken its role
    as a minimum viable example program.
  * d/tests: Use the example from docs/hello.c as our smoke-test
  * Update Lintian overrides for use of a release tarball

 -- Simon McVittie <smcv@debian.org>  Thu, 22 Jan 2026 13:41:22 +0000

=== debian/rules ===
--- 
+++ 
@@ -38,50 +38,81 @@
 confflags += -DSDLMIXER_TESTS_INSTALL=ON
 endif
 
+# Simple built-in formats
+confflags += -DSDLMIXER_AIFF=ON
+confflags += -DSDLMIXER_AU=ON
+confflags += -DSDLMIXER_VOC=ON
+confflags += -DSDLMIXER_WAVE=ON
+
 confflags += -DSDLMIXER_FLAC=ON
 confflags += -DSDLMIXER_FLAC_LIBFLAC=ON
+confflags += -DSDLMIXER_FLAC_LIBFLAC_SHARED=OFF
 confflags += -DSDLMIXER_FLAC_DRFLAC=OFF
 
 # gme has caused security issues in the past, so the conservative approach
-# is to leave it switched off until someone needs it
+# is to leave it switched off until someone needs it.
+# Please open a bug if this feature is required for a particular game.
 confflags += -DSDLMIXER_GME=OFF
+confflags += -DSDLMIXER_GME_SHARED=OFF
 
 # Enabling a previously disabled format is more compatible than disabling a
 # previously enabled format, so initially turn off MIDI for the SDL3 branch.
+# Please open a bug if this feature is required for a particular game.
 confflags += -DSDLMIXER_MIDI=OFF
 # Historically we enabled both fluidsynth and timidity by default, but it's
 # not clear that it was useful to do so.
 confflags += -DSDLMIXER_MIDI_FLUIDSYNTH=OFF
-confflags += -DSDLMIXER_MIDI_NATIVE=OFF
+confflags += -DSDLMIXER_MIDI_FLUIDSYNTH_SHARED=OFF
 confflags += -DSDLMIXER_MIDI_TIMIDITY=OFF
 
 # Enabling a previously disabled format is more compatible than disabling a
 # previously enabled format, so initially turn off soundtracker playback
 # for the SDL3 branch.
+# Please open a bug if this feature is required for a particular game.
 confflags += -DSDLMIXER_MOD=OFF
 confflags += -DSDLMIXER_MOD_XMP=OFF
 confflags += -DSDLMIXER_MOD_XMP_LITE=OFF
+confflags += -DSDLMIXER_MOD_XMP_SHARED=OFF
 
 confflags += -DSDLMIXER_MP3=ON
 confflags += -DSDLMIXER_MP3_DRMP3=OFF
 confflags += -DSDLMIXER_MP3_MPG123=ON
+confflags += -DSDLMIXER_MP3_MPG123_SHARED=OFF
 
 confflags += -DSDLMIXER_OPUS=ON
-confflags += -DSDLMIXER_SNDFILE=OFF
-confflags += -DSDLMIXER_VORBIS=VORBISFILE
-confflags += -DSDLMIXER_WAVE=ON
+confflags += -DSDLMIXER_OPUS_SHARED=OFF
+
+confflags += -DSDLMIXER_VORBIS_STB=OFF
+confflags += -DSDLMIXER_VORBIS_TREMOR=OFF
+confflags += -DSDLMIXER_VORBIS_VORBISFILE=ON
+confflags += -DSDLMIXER_VORBIS_VORBISFILE_SHARED=OFF
 
 # Enabling a previously disabled format is more compatible than disabling a
 # previously enabled format, so initially turn off wavpack for the SDL3
 # branch.
+# Please open a bug if this feature is required for a particular game.
 confflags += -DSDLMIXER_WAVPACK=OFF
+confflags += -DSDLMIXER_WAVPACK_DSD=OFF
+confflags += -DSDLMIXER_WAVPACK_SHARED=OFF
+
+CC ?= $(DEB_HOST_GNU_TYPE)-gcc
+PKG_CONFIG ?= $(DEB_HOST_GNU_TYPE)-pkgconf
 
 %:
-	dh $@ --buildsystem=cmake
+	dh $@ --buildsystem=cmake -Bcmake-build
 
 override_dh_auto_configure:
 	echo "$(DEB_VERSION_UPSTREAM_REVISION)" > VERSION.txt
 	dh_auto_configure -- $(confflags)
+
+execute_after_dh_auto_build:
+	$(CC) $(CPPFLAGS) $(CFLAGS) $(LDFLAGS) \
+		-o debian/simple-player \
+		docs/hello.c \
+		-I$(CURDIR)/include \
+		-L$(CURDIR)/cmake-build \
+		-lSDL3_mixer \
+		$$($(PKG_CONFIG) --cflags --libs sdl3)
 
 override_dh_compress:
 	dh_compress -Xplaymus.c -Xplaywave.c

=== debian/watch ===
Version: 5

# Upstream releases official source tarballs, so we use
# those in preference to git tags
Source: https://github.com/libsdl-org/SDL_mixer/tags
Matching-Pattern: .*/releases/tag/(?:prerelease|preview|release)-?@ANY_VERSION@
Compression: xz
Download-Url-Mangle: s#/tag/#/download/#;s#((?:prerelease|preview|release)-?@ANY_VERSION@)$#$1/SDL3_mixer-$2.tar.gz#
Dversion-Mangle: s/[+~](?:ds|dfsg)[0-9]*$//;s/\+(?:git)?[0-9]+(?:\+g[0-9a-f]*)?$//
Filename-Mangle: s#(?:prerelease|preview|release)-?@ANY_VERSION@#SDL3_mixer-$1.tar.gz#
Pgpmode: auto
Repack: yes
Repacksuffix: +ds
